#include "StdAfx.h"
#include "Sqlite3DB.h"
#include "Sqlite3Statement.h"

CSqlite3DB::CSqlite3DB(void)
{
	m_pSQLite = NULL;
}

CSqlite3DB::~CSqlite3DB(void)
{
	Close();
}

CSqlite3DB::operator sqlite3*()
{
	return m_pSQLite;
}

int CSqlite3DB::Open(TCHAR *szFile)
{
	int nResult = -1;
	if (szFile)
	{
		std::string file = UnicodeToUTF8(szFile);
		nResult = sqlite3_open(file.c_str(), &m_pSQLite);
	}

	return nResult;
}

int CSqlite3DB::Close()
{
	int nResult = SQLITE_OK;
	if (m_pSQLite)
	{
		nResult = sqlite3_close(m_pSQLite);
	}

	m_pSQLite = NULL;
	return nResult;
}

int CSqlite3DB::CreateStatement(const char *szSQL,CSqlite3Statement &stmt)
{
	return stmt.Create(m_pSQLite,szSQL);
}


int CSqlite3DB::ExecuteCommand(const char *szSQL)
{
	if (!m_pSQLite)
	{
		return -1;
	}

	char *szError = NULL;
	int nResult = sqlite3_exec(m_pSQLite, szSQL, NULL, NULL, &szError);
	if (nResult == SQLITE_OK)
	{
		nResult = sqlite3_changes(m_pSQLite);
	}

	return nResult;
}
